
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  RoyalBlue//wicks
#property indicator_color2  Red//wicks
#property indicator_color3  RoyalBlue // Candle Bodies
#property indicator_color4  Red // Candle Bodies

extern int    Candle_MA_Period	 = 34;
extern int    Candle_MA_Shift     = 0;
extern int    Candle_Type	       = 1;
extern int    Candle_MA_Price   	 = 0;
extern int    Candle_Shadow_Width = 1;
extern int    Candle_Body_Width   = 3;
extern string Type_Key            = "0: SMA, 1: EMA, 2: SMMA, 3: LWMA"; 
extern string Price_Key           = "0: Close, 1: Open, 2: High";
extern string Price_Key_cont      = " 3: Low, 4: Median";

extern bool   alertsOn            = false;
extern bool   alertsOnCurrent     = true;
extern bool   alertsMessage       = true;
extern bool   alertsSound         = false;
extern bool   alertsEmail         = false;
extern bool   alertsNotify        = false;
extern string soundFile           = "alert2.wav";

extern bool   ShowLines           = false;
extern string LinesIdentifier     = "MCLines1";
extern color  LinesColorForUp     = LimeGreen;
extern color  LinesColorForDown   = Red;
extern int    LinesStyle          = STYLE_DOT;

//
//
//
//
//

double Bar1[], Bar2[], Candle1[], Candle2[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(5);   
   SetIndexBuffer(0,Bar1);    SetIndexStyle(0,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexBuffer(1,Bar2);    SetIndexStyle(1,DRAW_HISTOGRAM,0,Candle_Shadow_Width);
   SetIndexBuffer(2,Candle1); SetIndexStyle(2,DRAW_HISTOGRAM,0,Candle_Body_Width);
   SetIndexBuffer(3,Candle2); SetIndexStyle(3,DRAW_HISTOGRAM,0,Candle_Body_Width);	
   SetIndexBuffer(4,trend);
   IndicatorShortName("Price cross Ma Candles"); 
return(0);
}  
int deinit()
{
   int lookForLength = StringLen(LinesIdentifier);
   for (int i=ObjectsTotal(); i>=0; i--)
      {
         string name = ObjectName(i);
         if (StringSubstr(name,0,lookForLength)==LinesIdentifier) ObjectDelete(name);
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() 
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

     for(i=limit; i>=0; i--)
     {
        double ma = iMA(NULL,0,Candle_MA_Period,Candle_MA_Shift,Candle_Type, Candle_MA_Price,i);
        double pr = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);
       
        Bar1[i]    = EMPTY_VALUE;
        Bar2[i]    = EMPTY_VALUE;
        Candle1[i] = EMPTY_VALUE;
        Candle2[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
           if (pr>ma) trend[i] = 1;
           if (pr<ma) trend[i] =-1;
           
           //
           //
           //
           //
           //
           
           if (trend[i] == 1)
           {
             Bar1[i]    = High[i];	
             Bar2[i]    = Low[i]; 
             Candle1[i] = MathMax(Open[i],Close[i]);	
             Candle2[i] = MathMin(Open[i],Close[i]);
           }
           if (trend[i] ==-1)
           {
             Bar2[i]    = High[i];	
             Bar1[i]    = Low[i]; 
             Candle2[i] = MathMax(Open[i],Close[i]);	
             Candle1[i] = MathMin(Open[i],Close[i]);
           }
           
           //
           //
           //
           //
           //
           
           if (ShowLines)
           {
              deleteLine(i);
              if (trend[i]!=trend[i+1])
              if (trend[i]==1)
                    drawLine(i,LinesColorForUp);
              else  drawLine(i,LinesColorForDown);
           }          
   }
   
   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed up");
      else  doAlert("crossed down");       
   } 
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," MA_Candles_Two_Colors ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," MA_Candles_Two_Colors "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void deleteLine(int i)
{
   ObjectDelete(LinesIdentifier+":"+Time[i]);
}
void drawLine(int i, color theColor)
{
   string name = LinesIdentifier+":"+Time[i];
   if (ObjectFind(name)<0)
       ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
       ObjectSet(name,OBJPROP_COLOR,theColor);
       ObjectSet(name,OBJPROP_BACK,true);
       ObjectSet(name,OBJPROP_STYLE,LinesStyle);
}

